#define T2_OUT(x)     TIM2->CCMR3 = TIM2->CCMR2 = x;
#define T2_OUT_CCR(x) TIM2->CCR3H = TIM2->CCR2H = x>>8; \
                      TIM2->CCR3L = TIM2->CCR2L = (u8)x;

volatile bool iwdg_t2;

u8 Bta_angle;

extern "C"
{
 INTERRUPT_HANDLER(TIM2_UPD_OVF, 13)
 {
  //   
  T2_OUT(force_inactive);

  //   ,     
  TIM2->IER = TIM2_IER_CC1IE|TIM2_IER_UIE;

  iwdg_t2 = true;
  TIM2->SR1 = 0;
 }

 INTERRUPT_HANDLER(TIM2_CAPCOM,  14)
 {
  const u16 min_capt_val  = (u16)((u32)mcu_freq/16/65/2);
  const u16 max_capt_val  = (u16)((u32)mcu_freq/16/40/2);
  static u16 pulse_length = 500; //us    1

  static u16 capt_val;
  static u8 stage;
  static u16 pulse;
  static u16 tmp;

  //  
  if(TIM2->SR1 & TIM2_SR1_CC1IF)
  {
   capt_val   = (u16)TIM2->CCR1H << 8;
   capt_val  += TIM2->CCR1L;
   capt_val >>= 1;

   //,     
   if(capt_val < min_capt_val) goto exit_cc2;
   else if(capt_val > max_capt_val)
   {
    TIM2->EGR = TIM2_EGR_UG;

    //   
    T2_OUT(force_inactive);

    goto exit_cc2;
   }

   // 
   T2_OUT(force_inactive);

   TIM2->EGR = TIM2_EGR_UG;

   //   
   stage = 0;

   //        
   if(Bta_angle == 0)
   {
    //     
    TIM2->IER = TIM2_IER_CC1IE|TIM2_IER_UIE;

    goto exit_cc2;
   }
   else if(Bta_angle == 180)
   {
    T2_OUT(force_active);

    //     
    TIM2->IER = TIM2_IER_CC1IE|TIM2_IER_UIE;

    goto exit_cc2;
   }
   else
   {
    if(Bta_angle > 120)pulse_length = 2000;
    else               pulse_length = 500;
   }

   //   
   pulse = capt_val - (u32)Bta_angle * capt_val /180;

   T2_OUT_CCR(pulse);

   //     
   T2_OUT(active_on_match);

   //   
   TIM2->IER = TIM2_IER_CC1IE|TIM2_IER_CC2IE|TIM2_IER_UIE;
  }
  //  
  else
  {
   switch(stage)
   {
    //    
    case 0:
    {
     //  
     tmp = pulse + pulse_length;

     T2_OUT_CCR(tmp);

     //     
     T2_OUT(inactive_on_match);
    }break;
    // ,    
    case 1:
    {
     pulse = capt_val + pulse;

     T2_OUT_CCR(pulse);

     //     
     T2_OUT(active_on_match);
    }break;
    //    
    case 2:
    {
     //  
     tmp = pulse + pulse_length;

     T2_OUT_CCR(tmp);

     //     
     T2_OUT(inactive_on_match);
    }break;

    default:
    {
     stage = 0;
     //   ,     
     TIM2->IER = TIM2_IER_CC1IE|TIM2_IER_UIE;

     // 
     T2_OUT(force_inactive);
    }break;
   }

   stage++;
  }

  exit_cc2:

  iwdg_t2 = true;
  TIM2->SR1 = 0;
 }
}